/* This files contains useful fonctions like assertions */

#include <stdio.h>
#include <stdlib.h>
#include "common.h"

void assert_cuda(cudaError_t err_id)
{
    if( err_id != cudaSuccess )
    {
	printf("%s\n",cudaGetErrorString(err_id));
	exit(EXIT_FAILURE);
    }
}

void assert_cu(CUresult res_id)
{
    if( res_id != CUDA_SUCCESS )
    {
	printf("Error in driver api returned with code: %d\n",res_id);
	exit(EXIT_FAILURE);
    }
}

void assert_gdr(int gdr_id)
{
    if( gdr_id != 0 )
    {
	printf("Error in gdr api returned with code: %d\n",gdr_id);
	exit(EXIT_FAILURE);
    }
}

void init_to_send(const void* dataPtr, size_t nb_bytes)
{
    FILE* filePtr = fopen("/home/mathiasb/sources/gpuFirstComm/to_send","wb");
    if( filePtr == NULL )
    {
	printf("Could not open to_send file. Exiting...\n");
	exit( EXIT_FAILURE );
    }
    int errCheck;
    errCheck = fwrite(dataPtr,nb_bytes,1,filePtr);
    if( errCheck == 0 )
    {
	printf("Could not write the items. Exiting...\n");
	exit( EXIT_FAILURE );
    }
    fclose(filePtr);
}
